import { Octave, PitchClass } from 'types.js';
export declare const PITCH_STANDARD: {
    pitchClass: PitchClass;
    octave: Octave;
    midi: number;
    frequency: number;
};
export declare const NUMBER_OF_PITCH_CLASSES = 12;
export declare const SEMITONE: number;
export declare const SHARP_CLASS_NOTES: readonly ["C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"];
export declare const FLAT_CLASS_NOTES: readonly ["C", "Db", "D", "Eb", "E", "F", "Gb", "G", "Ab", "A", "Bb", "B"];
export declare const PITCH_CLASS_LETTERS: readonly ["C", "D", "E", "F", "G", "A", "B"];
export declare const PITCH_CLASSES: readonly ["C", "C#", "Db", "D", "D#", "Eb", "E", "F", "F#", "Gb", "G", "G#", "Ab", "A", "A#", "Bb", "B"];
export declare const INTERVALS: {
    readonly U: 0;
    readonly m2: 1;
    readonly M2: 2;
    readonly m3: 3;
    readonly M3: 4;
    readonly P4: 5;
    readonly aug4: 6;
    readonly dim5: 6;
    readonly P5: 7;
    readonly m6: 8;
    readonly M6: 9;
    readonly m7: 10;
    readonly M7: 11;
    readonly P8: 12;
};
export declare const OCTAVES_ON_PIANO: 8;
export declare const NOTE_DURATIONS: readonly [1, 2, 4, 8, 16, 32, 64];
export declare const TIME_SIG_NUMERATORS: readonly [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
export declare const NOTE_DURATIONS_AS_SIZE_IN_MEASURE: {
    readonly '1n': 64;
    readonly '2n': 32;
    readonly '2n.': 48;
    readonly '2t': 21;
    readonly '4n': 16;
    readonly '8n': 8;
    readonly '16n': 4;
    readonly '32n': 2;
    readonly '64n': 1;
};
