import { Note } from 'types';
/**
 * Calculate the frequency of a note by its octave and index out of all notes(c, c#, etc...).
 * @param {String} note
 * @returns {Number}
 */
export declare function freqFromPitch(note: Note): number;
/**
 * Turns a midi value to frequency.
 * @param {Number} midi
 * @returns {number}
 */
export declare function freqFromMidi(midi: number): number;
/**
 * Turns a frequency value to midi note.
 * @param frequency
 * @returns {number}
 */
export declare function freqToFloatMidi(frequency: number): number;
/**
 * Turns frequency value to a ABSOLUTE midi note.
 * @param {Number} frequency
 * @returns {number}
 */
export declare function freqToMidi(frequency: number): number;
/**
 * Returns how much cents off a frequency is from an absolute note.
 * @param {Number} frequency
 * @param {Number} midi
 * @returns {number}
 */
export declare function centsOffFromFreq(frequency: number, midi: number): number;
/**
 * Generate frequency from real number.
 * @param realNumber
 * @returns {Number}
 */
export declare function midiToFreq(realNumber: number): number;
